    % Example script to move robot with Matlab commands. Runs on computer
% connected to Robot or on a remote computer
% -------------------------------------------------------------------------
% Launch the teaching pendant program LV_COM_FRM before launching this script.
% See: http://classes.engineering.wustl.edu/ese497/index.php/Fanuc_How_Tos,_FAQ,_etc.#FAQ
% for detailed instructions.
% -------------------------------------------------------------------------
% Messages are sent from this script to the LabVIEWMatlabFanuc.exe to 
% communicate the new position of the robot. The first 4 bytes of 
% the message are the length of the message in ASCII and that the message 
% is floating point numbers delimited by commas. You need to wait until it 
% receives an 'Ack' message back from LabVIEW.
% -------------------------------------------------------------------------
% If this is the computer that also communicates with the robot, then set
% host to 'localhost'. In this case, the script will launch 
% LabVIEWMatlabFanuc.exe. This is the application that receives message
% over TCP/IP from this script and communicates the coordinates to the
% program running on the robot.
% If this is NOT the computer that communicates with the robot, then set
% host to 'fanucomp.seasad.wustl.edu' or whatever the IP is for that
% computer. You will have to manually run LabVIEWMatlabFanuc.exe on that
% computer and set the IP to this computer's address. You have to stop the 
% application to change the IP. The application also starts minimized so
% you'll have to find it in the taskbar.
% -------------------------------------------------------------------------
% Matlab to LabVIEW communication based on
% http://www.mathworks.com/matlabcentral/fileexchange/42567-matlab-and-labview-data-exchange-over-tcp-ip
% Modified to pre-pend the length the the xmit string and to return the
% received message as a string
% -------------------------------------------------------------------------
% clear all; close all;

   

%connection settings - if directly connected to Fanuc use localhost, else
%use Fanucomp.seas.wustl.edu. See above for more details
host='localhost';   
%host='Fanucomp.seasad.wustl.edu';   


% Launch LabVIEW program that receives TCP/IP commands and communicates
% with the Robot
if (strcmp(host,'localhost'))
    !start /min "" LabVIEW2Fanuc\builds\MatlabLabVIEWFanuc\MatlabLabVIEWFanuc.exe
end

% Message format is X,Y,Z,Pitch,Roll,Yaw,Gripper,Tool Frame

values_to_send = [  [310 0 0 90 90 90 0 0]; ...            % Small move in X
                    [400 0 0 90 90 90 0 0]; ...            % Back to Home
                    ];                     
values_to_send = [ [400 0 0 90 90 90 1 0];...        % Open Gripper
                    [400 0 0 90 90 90 0 0];          % Close Gripper
                    ];
                
for i = 1:size(values_to_send,1)
    [data_received] =exchangeData(host,Double2CSV(values_to_send(i,:))) 
    pause(5) % wait 5 seconds after each task
end


if (strcmp(host,'localhost'))
    !taskkill /IM MatlabLabVIEWFanuc.exe
end
