// Privilege.cpp

#include "stdafx.h"
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include "privilege.h"

void Privilege(TCHAR* pszPrivilege, BOOL bEnable)
{
    HANDLE           hToken;
    TOKEN_PRIVILEGES tp;
    BOOL             status;
    DWORD            error;

    // open process token
    if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
	      _tprintf(TEXT("OpenProcessToken (%d).\n"),
             GetLastError());

    // get the luid
    if (!LookupPrivilegeValue(NULL, pszPrivilege, &tp.Privileges[0].Luid))
	      _tprintf(TEXT("LookupPrivilegeValue (%d).\n"),
             GetLastError());
 
    tp.PrivilegeCount = 1;

    // enable or disable privilege
    if (bEnable)
        tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
    else
        tp.Privileges[0].Attributes = 0;

    // enable or disable privilege
    status = AdjustTokenPrivileges(hToken, FALSE, &tp, 0, (PTOKEN_PRIVILEGES)NULL, 0);

    // It is possible for AdjustTokenPrivileges to return TRUE and still not succeed.
    // So always check for the last error value.
    error = GetLastError();
    if (!status || (error != ERROR_SUCCESS))
	      _tprintf(TEXT("AdjustTokenPrivileges (%d).\n"),
             GetLastError());

    // close the handle
    if (!CloseHandle(hToken))
	      _tprintf(TEXT("CloseHandle (%d).\n"),
             GetLastError());

}