function [cart] = proj2cart(proj,w,h,xFOV,yFOV)
% proj in Nx3 array where col 1 is pixelX and col2 is pixelY and col3 is cartesian Z
% Converts from Camera Pixel Coordinates and Real World Depth to 
% RealWorld x,y,z
% Best FOVx,FOVy is 63.1,49.6 found experimentally using FindBestFOVs.m
xFocalLength = w/2/tan(xFOV/2*pi/180) ;
yFocalLength = h/2/tan(yFOV/2*pi/180) ;

cart = double(proj) ;
for i = 1:size(proj,1)
    if ( i == 64 )
        i = i ;
    end
    %See Kinect Projection to Cartesion Conversion.docx for details
    cart(i,1) = cart(i,3)*(cart(i,1)-320)/xFocalLength ;
    cart(i,2) = cart(i,3)*(cart(i,2)-240)/yFocalLength ;
end    
